Subject: bug#13334: 24.3.50; enhancement request: `C-0 M-n' reverses order of defaults

From: "Drew Adams" <[email-masked]>
Date: Wed, 2 Jan 2013 16:49:29 -0800

> > The enhancement would be to let a zero prefix arg (e.g. 
> > `C-0') reverse the list of available default values and
> > then go to the first one (previously the last one).
> > So you could cycle among the defaults in the opposite order.
> 
> Much more useful would be to display a complete list of suggestions,
> so the users would be able to select the necessary element easily.
> 
> This is how it works in web browsers: a drop-down list with 
> suggestions is displayed where you can use up/down-arrow keys to select 
> the suggestion.
> Web browsers combine two types of lists into one suggestion box:
> previously entered elements from the history and new suggestions
> (often based on popular searches).
> 
> In Emacs the keybinding that works like this is <prior> or M-v
> (`switch-to-completions').  But currently it doesn't display 
> suggestions.  It could be enhanced to sort completions and put
> suggestions on the top of the *Completions* list.

No, please do not do any such thing.  Please keep *Completions* separate.  Do
not mix such "suggestions" or past inputs with completion candidates.

Simply adding the default value(s) to the history is enough, provided you also
do what is done in Icicles: provide a minibuffer key (available always, not just
during completion) that lets you complete against the history list.  I use `M-o'
for this (by default).

You can pull any number of history elements into the same minibuffer input you
are composing, any number of times.  And you can use completion to access the
history elements.  (And they are kept separate from the completion candidates of
the parent minibuffer - you are completing only against history elements.)

http://www.emacswiki.org/emacs/Icicles_-_History_Enhancements#InsertPreviousInpu
ts

If you want to move beyond the existing M-n, M-p, M-s, M-r for vanilla Emacs,
then please consider using an enhancement like the Icicles M-o.